use thiserror::Error;

#[derive(Error, Debug)]
#[error("data store error")]
pub enum DataStoreError {
    #[error("no results")]
    NoResults(rusqlite::Error),
    #[error("sqlite error")]
    SqliteError(rusqlite::Error),
    #[error("connection error")]
    ConnectionError(#[from] r2d2::Error),
}

impl From<rusqlite::Error> for DataStoreError {
    fn from(error: rusqlite::Error) -> Self {
        match error {
            rusqlite::Error::QueryReturnedNoRows => DataStoreError::NoResults(error),
            _ => DataStoreError::SqliteError(error),
        }
    }
}
